﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Dim nativeme As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	nativeme = Me
	
End Sub

public Sub drawCode128 (data As String, width As Int, height As Int) As Bitmap
	Return nativeme.RunMethod("drawCode128", Array(data, width, height))
End Sub

public Sub decodeCode128( data As Bitmap) As String
	Return nativeme.RunMethod("decodeCode128", Array( data ))	
End Sub


#if Java
import android.graphics.Bitmap;
import android.graphics.Point;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.content.Context;
import java.lang.String;

import java.util.Collection;
import java.util.EnumMap;
import java.util.HashSet;
import java.util.Map;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.DecodeHintType;
import com.google.zxing.datamatrix.DataMatrixReader;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.ArrayList;

// ---------------------------------------------------------------
import android.graphics.BitmapFactory;
import com.google.zxing.BinaryBitmap;
import com.google.zxing.ChecksumException;
import com.google.zxing.FormatException;
import com.google.zxing.LuminanceSource;
import com.google.zxing.NotFoundException;
//import com.google.zxing.IOException;
import com.google.zxing.RGBLuminanceSource;
import com.google.zxing.Result;
import com.google.zxing.common.HybridBinarizer;
import com.google.zxing.oned.Code128Reader;
import com.google.zxing.oned.Code128Writer;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import com.google.zxing.common.StringUtils;
import com.google.zxing.Reader;
import com.google.zxing.ResultMetadataType;
import java.util.Formatter;

import java.nio.ByteBuffer;

public Bitmap drawCode128(String text, int width, int height) {

	BitMatrix bitMatrix;
    try {
	
		bitMatrix = new Code128Writer().encode(text, BarcodeFormat.CODE_128, width, height); 
		
        int colorWhite = 0xFFFFFFFF;
        int colorBlack = 0xFF000000;

	    Bitmap bmp = Bitmap.createBitmap(width, height, Bitmap.Config.RGB_565);
    	for (int x = 0; x < width; x++){
        	for (int y = 0; y < height; y++){
            	bmp.setPixel(x, y, bitMatrix.get(x,y) ? 0xff000000 : 0xffffffff);
        	}
    	}
		
		BA.Log("returning bitmap: " + bmp.getWidth() + " x " + bmp.getHeight());
        return bmp;
    } catch (Exception i) {
        BA.Log("some problem: " + i.toString());
        return null;
    }
}

public String decodeCode128( Bitmap bmp) {
	String encoding = "";
    String decoded = null;
	
    int[] intArray = new int[bmp.getWidth() * bmp.getHeight()];
    bmp.getPixels(intArray, 0, bmp.getWidth(), 0, 0, bmp.getWidth(),bmp.getHeight());
    LuminanceSource source = new RGBLuminanceSource(bmp.getWidth(), bmp.getHeight(), intArray);
    BinaryBitmap bitmap = new BinaryBitmap(new HybridBinarizer(source));


    Reader reader = null;
	
	
    try {
       reader = new Code128Reader();
		  
       Result result =	reader.decode(bitmap);
       decoded = result.getText();
	   
       BA.Log("Code128 text: " + decoded);

    } catch (NotFoundException e) {
        BA.Log(e.toString());
		decoded = "Fail: " + e.toString();
    } catch (ChecksumException e) {
        BA.Log(e.toString());
        decoded = "Fail: " + e.toString();
    } catch (FormatException e) {
        BA.Log(e.toString());
        decoded = "Fail: " + e.toString();
    }
   return decoded;
}

#End If